/******************************************************************************

	rar.c

	Simulate HP9845 BPC binary integer rotate right instructions (RAR, RBR)
	
	Usage: rar <arg>
	
	(c) 2006 by Ansgar Kueckes (kueckes@alice-dsl.net)

******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

void bpc_rar(long *reg, int count)
{
  long a;
  int i,lsb;

  /* integer rotate right */
  a=*reg; if (a<0) a+=65536;
  for (i=0; i<count; i++) {
  	lsb=a&0x01;
  	a>>=1;
  	if (lsb) a|=0x8000;
  }

  if (a>32767) a-=65536;
  *reg=a;
}

void bpc_clear_bit15(long *reg)
{
  long a;
   
  a=*reg; if (a<0) a+=65536;
  a&=0x7FFF;
   
  //if (a>32767) a-=65536;
  *reg=a; 
}


int main(int argc, char *argv[])
{
  long arg1;

  arg1=atoi(argv[1]);
  //arg2=atoi(argv[2]);
  
  //bpc_rar(&arg1, arg2);
  //printf("result (rar): %ld\n", arg1);

  arg1=atoi(argv[1]);
  bpc_clear_bit15(&arg1);
  printf("result (clear): %ld\n", arg1);
  
  exit(0);
}
